#!/bin/bash
##author:gangouyang@tencent.com
##date:2020/04/15
##desc:bind selected device irq to the node which the device located

##nic/ahci/hba/raid##
devices=(
'/sys/class/net/*'
'/sys/bus/pci/drivers/ahci/*:*'
'/sys/bus/pci/drivers/mpt3sas/*:*'
'/sys/bus/pci/drivers/mpt2sas/*:*'
)
ncores=`ls /sys/devices/system/node/node0/|grep cpu[0-9]|wc -l`
node_num=`ls /sys/devices/system/node/|grep node|wc -l`

for((node=0;node<$node_num;node++));do
	core_header[$node]=1
done;
for dev in ${devices[@]};do
	##no device in this class
	echo $dev|grep '\*' >>/dev/null 
	if [ $? -eq 0 ];then
		continue;
	fi 
	##get irqs
	irqs=''
	ls $dev/device/msi_irqs/ > /dev/null 2>&1
	if [ $? -eq 0 ];then 
	    irqs=`ls $dev/device/msi_irqs/|sed 's/ //g'`
	    dev_dir=$dev/device
	fi
	ls $dev/msi_irqs/ > /dev/null 2>&1
	if [ $? -eq 0 ];then 
	    irqs=`ls $dev/msi_irqs/|sed 's/ //g'`
	    dev_dir=$dev
	fi 
	##determine numa_node info
	[ -e $dev_dir/numa_node ] && node=$(<$dev_dir/numa_node)
	[ "$node" ] && [ "$node" -gt 0 ] || node=0
	
	##get core header
	n=${core_header[$node]};

	##bind irq 
	for IRQ in $irqs; do
		if [ "$n" -gt "$ncores" ];then 
		   n=1
		fi ##start another round after all cpu used.
	        ls /proc/irq/$IRQ/smp_affinity_list >>/dev/null 2>&1
	        if [ $? -ne 0 ];then
        	        continue;
	        fi
		core=`ls /sys/devices/system/node/node$node/|grep cpu[0-9]|cut -b 4-|sort -n|sed -n "$n"p`
		echo $core > /proc/irq/$IRQ/smp_affinity_list
		((n++))
	done
	##update core header
	core_header[$node]=$n
done
exit 0;

##nvme##
nvmelist=`ls /sys/class/nvme`;
for nvme in $nvmelist;do
	for nvmep in `ls -d /sys/class/nvme/$nvme/nvme*`;do
		nvmed=`echo $nvmep|rev |cut -d '/' -f 1|rev`
		#echo $nvmed
		irq=`cat /proc/interrupts |grep -iw "$nvme"q0|awk -F ':' '{print$1}'|awk '$1=$1'`
		node=`cat /sys/class/nvme/$nvme/device/numa_node`
		if [ $node == '0' ];then
                	corelist=`lstopo-no-graphics |grep -i "Socket L#$node" -A 100 |grep PU|head -n 2|cut -d "#" -f 3|cut -d ")" -f 1` 
	                corelist=`echo $corelist |sed 's/ /,/g'`
        	else
                	corelist=`lstopo-no-graphics |grep -i "Socket L#$node" -A 100 |grep PU|head -n 2|cut -d "#" -f 3|cut -d ")" -f 1` 
	                corelist=`echo $corelist |sed 's/ /,/g'`
        	fi 
		echo $corelist > /proc/irq/"$irq"/smp_affinity_list 
		#cpulist_irq=`cat /proc/irq/$irq/smp_affinity_list` 
		#echo "nvme $nvmed adminq irq $irq cpulist_irq $cpulist_irq";
		##io queue##
		for((i=0;i<$(ls -d /sys/class/nvme/$nvme/$nvmed/mq/*|wc -l);i++));do
			cpulist_mp=`cat /sys/class/nvme/$nvme/$nvmed/mq/$i/cpu_list`;
			qid=`echo "$i+1"|bc` ##nvme driver rule
			qname="$nvme"q"$qid"
			irq=`cat /proc/interrupts |grep -iw $qname|awk -F ':' '{print$1}'|awk '$1=$1'`
			echo $cpulist_mp > /proc/irq/$irq/smp_affinity_list
			#cpulist_irq=`cat /proc/irq/$irq/smp_affinity_list` 
			#echo "nvme $nvmed mq $i cpulist_mp $cpulist_mp irq $irq cpulist_irq $cpulist_irq";
		done;
	done;
done;

