#!/bin/bash
if [ -e ~/corebalance ]
then 
	echo 1 > ~/corebalance/dir_num
else
	mkdir ~/corebalance
fi

rm -rf ~/corebalance/cpu_nvme
rm -rf ~/corebalance/balance.log

numa_node=$(lscpu | grep -i numa | sed -n "1p"| awk '{print $3}')
numa_arr=()
cpu_arr=()
nvme_line=$(lspci | grep -i non | wc -l)
count=0
cou=0
declare -A dic
cpu_group=()

for ((i=0;i<$numa_node;i++))
do
	numa_arr[$i]=$i
done

for node in ${numa_arr[@]}
do
	cpu_arr[$node]=$(echo "cpu$node")
done

for cpu in ${cpu_arr[@]}
do 
	rm -rf ~/corebalance/$cpu.log
done


for numa in ${numa_arr[@]}
do
	lspci | grep -i non | awk '{print $1}'|while read line;
	do 
		nvmename=$(ls /sys/bus/pci/devices/$line/nvme)
		numa_node=$(cat /sys/bus/pci/devices/$line/numa_node)
		if [ $numa == $numa_node ]
		then
			echo "${cpu_arr[$numa]}"[$count]=$nvmename>>~/corebalance/cpu_nvme
			let count++
		else
			echo "">~/corebalance/none
		fi
	done
done

cat /proc/interrupts | grep -i vmd | while read line;
do 
	irqname=$(echo $line | awk '{print $NF}');
	irqnum=$(echo $line | awk -F ":" '{print $1}');
	core=$(cat /proc/irq/$irqnum/smp_affinity_list);
	echo -e "$irqname  $irqnum  $core" | grep -i nvme >> ~/corebalance/balance.log
done


# nvme queue interrupts
for cpu in ${cpu_arr[@]}
do
	line=$(cat ~/corebalance/cpu_nvme|grep $cpu|awk -F "=" '{print $2}'| wc -l)

	[[ $line -eq 0 ]] && continue

	for ((i=1;i<=$line;i++))
	do
		nvme=$(cat ~/corebalance/cpu_nvme| grep $cpu| awk -F "=" '{print $2}'|sed -n "${i}p")
		cat ~/corebalance/balance.log | grep $nvme | awk '{print $2}'>>~/corebalance/$cpu.log
	done

	core_queue=()
	queue_num=$(cat ~/corebalance/$cpu.log | wc -l)
	queue_arr=()

	for ((i=0;i<$queue_num;i++))
	do
		let n=$i+1
		queue_arr[$i]=$(cat ~/corebalance/$cpu.log | sed -n "${n}p")
	done

	node=$(echo $cpu | cut -b 4-)
	core_num=$(ls /sys/devices/system/node/node$node/ |grep cpu | sort -r| sed '1,2d'| cut -b 4-|wc -l)

	for ((i=0;i<$core_num;i++))
	do
	let n=$i+1
	core_queue[$i]=$(ls /sys/devices/system/node/node$node | grep cpu | sort -r | sed '1,2d'| cut -b 4-|sed -n "${n}p")
	done

	if [ ${#queue_arr[@]} -lt ${#core_queue[@]} ]
	then
		echonum1=${#queue_arr[@]}
		for ((i=0;i<$echonum1;i++))
		do
			corenum1=${core_queue[$i]}
			echo "bind ${queue_arr[$i]} to core $corenum1"
			echo $corenum1 > /proc/irq/${queue_arr[$i]}/smp_affinity_list
		done
	else
		echonum2=${#core_queue[@]} 
		queue_arr_num=${#queue_arr[@]}

		for ((i=0;i<$queue_arr_num;i++))
		do
			core_queue_id=$(($i % $echonum2))
			corenum=${core_queue[$core_queue_id]}
			echo "bind ${queue_arr[$i]} to core $corenum"
			echo $corenum > /proc/irq/${queue_arr[$i]}/smp_affinity_list
		done
	fi
done

rm -rf ~/corebalance/vmd_VMD_PCIe.log
rm -rf ~/corebalance/vmd_VMD_MSI.log
rm -rf ~/corebalance/vmd_PCI_MSI.log
rm -rf ~/corebalance/vmd_all.log
rm -rf ~/corebalance/vmdcpu_irq
cat /proc/interrupts | grep -i vmd | while read line
do
	irqname=$(echo $line | awk '{print $NF}')
	irqnum=$(echo $line | awk -F ":" '{print $1}')
	core=$(cat /proc/irq/$irqnum/smp_affinity_list)
	irqtype=$(echo $line | awk '{print $(NF-1)}')
	echo -e "$irqnum $core $irqtype $irqname" | grep -v nvme >> ~/corebalance/vmd_all.log;
done
cat ~/corebalance/vmd_all.log | grep "VMD-MSI PCIe" >> ~/corebalance/vmd_VMD_PCIe.log;
cat ~/corebalance/vmd_all.log | grep "VMD-MSI" | grep -v PCIe >> ~/corebalance/vmd_VMD_MSI.log;
cat ~/corebalance/vmd_all.log | grep vmd >> ~/corebalance/vmd_PCI_MSI.log;

allcore=$(lscpu | grep On-line|awk  -F "-" '{print $3}')
cat ~/corebalance/vmd_all.log | grep VMD-MSI|while read line
do
	irq=$(echo $line| grep VMD-MSI | awk '{print $1}')
	echo "bind ${irq} to ALL CPU cores"
	echo "0-$allcore" > /proc/irq/$irq/smp_affinity_list
done

numa_node=$(lscpu | grep -i numa | sed -n "1p"| awk '{print $3}')
vmdcpu_arr=()
numa_arr=()
vmdcpu_group=()
count=0
for ((i=0;i<$numa_node;i++))
do
	numa_arr[$i]=$i
done

for node in ${numa_arr[@]}
do
	vmdcpu_arr[$node]=$(echo "cpu$node")
done

for vmdcpu in ${vmdcpu_arr[@]}
do
	rm -rf ~/corebalance/vmd$vmdcpu.log
done

for numa in ${numa_arr[@]}
do
	cat ~/corebalance/vmd_PCI_MSI.log | while read line;
	do
		irq=$(echo $line | awk '{print $1}')
		node=$(cat /proc/irq/$irq/node)
		if [ $numa == $node ]
		then
			echo "${vmdcpu_arr[$numa]}[$count]=$irq" >> ~/corebalance/vmdcpu_irq
			let count++
		else
			echo "" > ~/corebalance/none
		fi
	done
done


for cpu in ${vmdcpu_arr[@]}
do
	cat ~/corebalance/vmdcpu_irq | grep $cpu | awk -F "=" '{print $2}'>>~/corebalance/vmd$cpu.log
	queue_num=$(cat ~/corebalance/vmd${cpu}.log | wc -l)
	[[ $queue_num -eq 0 ]] && continue

	core_queue=()
	queue_arr=()
	for ((i=0;i<$queue_num;i++))
	do
		let n=$i+1
		queue_arr[$i]=$(cat ~/corebalance/vmd$cpu.log | sed -n "${n}p")
	done

	node=$(echo $cpu | cut -b 4-)
	core_num=$(ls /sys/devices/system/node/node$node/ |grep cpu | sort -r| sed '1,2d'| cut -b 4-|wc -l)

	for ((i=0;i<$core_num;i++))
	do
		let n=$i+1
		core_queue[$i]=$(ls /sys/devices/system/node/node$node | grep cpu | sort -r | sed '1,2d'| cut -b 4-|sed -n "${n}p")
	done

	if [ ${#queue_arr[@]} -lt ${#core_queue[@]} ]
	then
		echonum1=${#queue_arr[@]}
		for ((i=0;i<$echonum1;i++))
		do
			corenum1=${core_queue[$i]}
			echo "bind ${queue_arr[$i]} to core $corenum1"
			echo $corenum1 > /proc/irq/${queue_arr[$i]}/smp_affinity_list
		done
	else
		echonum2=${#core_queue[@]} 
		queue_arr_num=${#queue_arr[@]}

		for ((i=0;i<$queue_arr_num;i++))
		do
			core_queue_id=$(($i % $echonum2))
			corenum=${core_queue[$core_queue_id]}
			echo "bind ${queue_arr[$i]} to core $corenum"
			echo $corenum > /proc/irq/${queue_arr[$i]}/smp_affinity_list
		done
	fi
done

