#!/usr/libexec/platform-python
# -*- coding: utf-8 -*-

import os
import sys
import glob

BASEDIR = "/sys/class/net"

def int_to_mask(num, queues):
    result = 0
    mask=''
    if len(sys.argv) == 2 and sys.argv[1] == 'kvm':
        st = queues
    else:
        st = 0

    for i in range(st, num):
        result = result | (1 << i)
    if num > 32:
        result=hex(result)
        strhex=str(result)
        if num < 64:
            strhex=strhex[2:len(strhex)]
        else:
            strhex=strhex[2:len(strhex)-1]
        for i in range(0,len(strhex)):
            mask=strhex[len(strhex)-i-1]+mask
            if (i+1)!=len(strhex) and (i+1)%8==0:
                mask=','+mask
        return mask
    else:   
        return "%x" % result

def count_queues(netif, rx_or_tx):
    return len(glob.glob(os.path.join(BASEDIR, netif, "queues", rx_or_tx + "-*")))

def set_rps_cpus(netif, rx_or_tx, mask):
    for rps_cpus in glob.glob(os.path.join(BASEDIR, netif, "queues", rx_or_tx + "-*/rps_cpus")):
        try:
            f = open(rps_cpus, "w")
            f.write(mask)
            f.close()
        except exception as err:
            print("!! Failed to set rps_cpus for %s queues %s: %s !!" % (netif, rx_or_tx, err))
            sys.exit(1)

def main():
    cpuinfo = open("/proc/cpuinfo").read()
    cpu_count = len(cpuinfo.strip().split("\n\n"))
    print("cpu_count is %d" % cpu_count)
    for dirname in os.listdir(BASEDIR):
        if "eth" in dirname:
            direction = "rx"
            queues = count_queues(dirname, direction)
            print("%s has %d queues for %s" % (dirname, queues, direction))
            if queues < cpu_count:
                mask = int_to_mask(cpu_count, queues)
                print("mask is %s" % mask)
                set_rps_cpus(dirname, direction, mask)
                print("Successfully set rps_cpus for %s queues %s to %s" % (dirname, direction, mask))
if __name__ == "__main__":
    main()
